import * as i0 from '@angular/core';
import { InjectionToken, Injector, Component, ChangeDetectionStrategy, Inject, NgModule, Injectable } from '@angular/core';
import * as i3 from '@angular/material/dialog';
import { MAT_DIALOG_DATA, MatDialogModule } from '@angular/material/dialog';
import * as i1 from '@angular/common';
import { CommonModule } from '@angular/common';
import * as i2 from '@angular/material/button';
import { MatButtonModule } from '@angular/material/button';
import { __awaiter, __classPrivateFieldGet } from 'tslib';
import { ContentContainerComponentHarness, HarnessPredicate } from '@angular/cdk/testing';
import { MatButtonHarness } from '@angular/material/button/testing';
import { MatDialogHarness } from '@angular/material/dialog/testing';
import { firstValueFrom } from 'rxjs';

/**
 * Injection token for a custom dialog component to receive input. See {@link DialogData.slDialogData}.
 */
const SL_DIALOG_DATA = new InjectionToken('SL_DIALOG_DATA');
/**
 * The {@link DialogButton.value} for the default "OK" button that is used if you do not specify any custom buttons for your dialog.
 */
const DEFAULT_OK_VALUE = Symbol('OK');
class DialogComponent {
    constructor(data, injector) {
        var _a;
        this.data = data;
        (_a = data.buttons) !== null && _a !== void 0 ? _a : (data.buttons = [{ text: 'OK', value: DEFAULT_OK_VALUE }]);
        this.componentInjector = Injector.create({
            providers: [{ provide: SL_DIALOG_DATA, useValue: data.slDialogData }],
            parent: injector,
        });
    }
}
DialogComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "14.0.3", ngImport: i0, type: DialogComponent, deps: [{ token: MAT_DIALOG_DATA }, { token: i0.Injector }], target: i0.ɵɵFactoryTarget.Component });
DialogComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "14.0.3", type: DialogComponent, selector: "sl-dialog", ngImport: i0, template: "<h2 mat-dialog-title>{{ data.title ?? data.component?.title }}</h2>\r\n\r\n<mat-dialog-content class=\"mat-typography\">\r\n  <p *ngIf=\"data.text\">{{ data.text }}</p>\r\n  <ng-container *ngIf=\"data.component\">\r\n    <ng-container\r\n      *ngComponentOutlet=\"data.component; injector: componentInjector\"\r\n    ></ng-container>\r\n  </ng-container>\r\n</mat-dialog-content>\r\n\r\n<mat-dialog-actions align=\"end\">\r\n  <button\r\n    *ngFor=\"let button of data.buttons\"\r\n    mat-button\r\n    [mat-dialog-close]=\"button.value ?? button.text\"\r\n    [color]=\"button.color ?? 'primary'\"\r\n  >\r\n    {{ button.text }}\r\n  </button>\r\n</mat-dialog-actions>\r\n", styles: ["mat-dialog-actions button{text-transform:uppercase}\n"], dependencies: [{ kind: "directive", type: i1.NgComponentOutlet, selector: "[ngComponentOutlet]", inputs: ["ngComponentOutlet", "ngComponentOutletInjector", "ngComponentOutletContent", "ngComponentOutletNgModule", "ngComponentOutletNgModuleFactory"] }, { kind: "directive", type: i1.NgForOf, selector: "[ngFor][ngForOf]", inputs: ["ngForOf", "ngForTrackBy", "ngForTemplate"] }, { kind: "directive", type: i1.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { kind: "component", type: i2.MatButton, selector: "button[mat-button], button[mat-raised-button], button[mat-icon-button],             button[mat-fab], button[mat-mini-fab], button[mat-stroked-button],             button[mat-flat-button]", inputs: ["disabled", "disableRipple", "color"], exportAs: ["matButton"] }, { kind: "directive", type: i3.MatDialogClose, selector: "[mat-dialog-close], [matDialogClose]", inputs: ["aria-label", "type", "mat-dialog-close", "matDialogClose"], exportAs: ["matDialogClose"] }, { kind: "directive", type: i3.MatDialogTitle, selector: "[mat-dialog-title], [matDialogTitle]", inputs: ["id"], exportAs: ["matDialogTitle"] }, { kind: "directive", type: i3.MatDialogContent, selector: "[mat-dialog-content], mat-dialog-content, [matDialogContent]" }, { kind: "directive", type: i3.MatDialogActions, selector: "[mat-dialog-actions], mat-dialog-actions, [matDialogActions]", inputs: ["align"] }], changeDetection: i0.ChangeDetectionStrategy.OnPush });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "14.0.3", ngImport: i0, type: DialogComponent, decorators: [{
            type: Component,
            args: [{ selector: 'sl-dialog', changeDetection: ChangeDetectionStrategy.OnPush, template: "<h2 mat-dialog-title>{{ data.title ?? data.component?.title }}</h2>\r\n\r\n<mat-dialog-content class=\"mat-typography\">\r\n  <p *ngIf=\"data.text\">{{ data.text }}</p>\r\n  <ng-container *ngIf=\"data.component\">\r\n    <ng-container\r\n      *ngComponentOutlet=\"data.component; injector: componentInjector\"\r\n    ></ng-container>\r\n  </ng-container>\r\n</mat-dialog-content>\r\n\r\n<mat-dialog-actions align=\"end\">\r\n  <button\r\n    *ngFor=\"let button of data.buttons\"\r\n    mat-button\r\n    [mat-dialog-close]=\"button.value ?? button.text\"\r\n    [color]=\"button.color ?? 'primary'\"\r\n  >\r\n    {{ button.text }}\r\n  </button>\r\n</mat-dialog-actions>\r\n", styles: ["mat-dialog-actions button{text-transform:uppercase}\n"] }]
        }], ctorParameters: function () {
        return [{ type: undefined, decorators: [{
                        type: Inject,
                        args: [MAT_DIALOG_DATA]
                    }] }, { type: i0.Injector }];
    } });

var _SlDialogHarness_instances, _SlDialogHarness_getContent, _SlDialogHarness_getButton, _SlDialogHarness_getButtons, _SlDialogHarness_getFooter;
/**
 * Harness for interacting with a dialog opened via {@link SlDialogService.open}.
 */
class SlDialogHarness extends ContentContainerComponentHarness {
    constructor() {
        super(...arguments);
        _SlDialogHarness_instances.add(this);
        _SlDialogHarness_getContent.set(this, this.locatorFor('mat-dialog-content'));
    }
    /**
     * Gets a `HarnessPredicate` that can be used to search for a SlDialogHarness that meets certain criteria.
     */
    static with(options) {
        return new HarnessPredicate(SlDialogHarness, options).addOption('title', options.title, (harness, title) => __awaiter(this, void 0, void 0, function* () { return HarnessPredicate.stringMatches(harness.getTitle(), title); }));
    }
    getTitle() {
        return __awaiter(this, void 0, void 0, function* () {
            const title = yield this.locatorFor('[mat-dialog-title]')();
            return title.text();
        });
    }
    /**
     * Get the text displayed in the content of the dialog. Note this includes text from both the `text` and `component` options of {@link SlDialogService.open}.
     */
    getContentText() {
        return __awaiter(this, void 0, void 0, function* () {
            const content = yield __classPrivateFieldGet(this, _SlDialogHarness_getContent, "f").call(this);
            return content.text();
        });
    }
    /**
     * Return the text of all the buttons.
     */
    getButtonText() {
        return __awaiter(this, void 0, void 0, function* () {
            const buttons = yield __classPrivateFieldGet(this, _SlDialogHarness_instances, "m", _SlDialogHarness_getButtons).call(this);
            return Promise.all(buttons.map((button) => __awaiter(this, void 0, void 0, function* () { return button.getText(); })));
        });
    }
    /**
     * Return the text of all the buttons. Note that "default" corresponds to when you explicitly specify that color for the button, and is **not** the color of a button when you don't specify a color (see {@link DialogButton.color}).
     */
    getButtonColors() {
        return __awaiter(this, void 0, void 0, function* () {
            const buttons = yield __classPrivateFieldGet(this, _SlDialogHarness_instances, "m", _SlDialogHarness_getButtons).call(this);
            return Promise.all(buttons.map((button) => __awaiter(this, void 0, void 0, function* () {
                const host = yield button.host();
                if (yield host.hasClass('mat-primary')) {
                    return 'primary';
                }
                else if (yield host.hasClass('mat-accent')) {
                    return 'accent';
                }
                else if (yield host.hasClass('mat-warn')) {
                    return 'warn';
                }
                else {
                    return 'default';
                }
            })));
        });
    }
    clickButton(text) {
        return __awaiter(this, void 0, void 0, function* () {
            const button = yield __classPrivateFieldGet(this, _SlDialogHarness_instances, "m", _SlDialogHarness_getButton).call(this, text);
            yield button.click();
        });
    }
    /**
     * Closes the dialog by pressing escape.
     */
    close() {
        return __awaiter(this, void 0, void 0, function* () {
            const rootLoader = yield this.documentRootLocatorFactory().rootHarnessLoader();
            const dialog = yield rootLoader.getHarness(MatDialogHarness);
            yield dialog.close();
        });
    }
}
_SlDialogHarness_getContent = new WeakMap(), _SlDialogHarness_instances = new WeakSet(), _SlDialogHarness_getButton = function _SlDialogHarness_getButton(text) {
    return __awaiter(this, void 0, void 0, function* () {
        const footer = yield __classPrivateFieldGet(this, _SlDialogHarness_instances, "m", _SlDialogHarness_getFooter).call(this);
        return footer.getHarness(MatButtonHarness.with({ text }));
    });
}, _SlDialogHarness_getButtons = function _SlDialogHarness_getButtons() {
    return __awaiter(this, void 0, void 0, function* () {
        const footer = yield __classPrivateFieldGet(this, _SlDialogHarness_instances, "m", _SlDialogHarness_getFooter).call(this);
        return footer.getAllHarnesses(MatButtonHarness);
    });
}, _SlDialogHarness_getFooter = function _SlDialogHarness_getFooter() {
    return __awaiter(this, void 0, void 0, function* () {
        return this.getChildLoader('mat-dialog-actions');
    });
};
SlDialogHarness.hostSelector = 'sl-dialog';

/**
 * Import this module to enable use of {@linkcode SlDialogService}
 */
class SlDialogModule {
}
SlDialogModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "14.0.3", ngImport: i0, type: SlDialogModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
SlDialogModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "14.0.3", ngImport: i0, type: SlDialogModule, declarations: [DialogComponent], imports: [CommonModule, MatButtonModule, MatDialogModule] });
SlDialogModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "14.0.3", ngImport: i0, type: SlDialogModule, imports: [CommonModule, MatButtonModule, MatDialogModule] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "14.0.3", ngImport: i0, type: SlDialogModule, decorators: [{
            type: NgModule,
            args: [{
                    imports: [CommonModule, MatButtonModule, MatDialogModule],
                    declarations: [DialogComponent],
                }]
        }] });

/**
 * Shows simple text dialogs with just a method call, and reduces boilerplate for more complex dialogs.
 *
 * A simple text dialog:
 * ```ts
 * const choice = await slDialogService.open({
 *   text: 'Discard draft?',
 *   buttons: [{ text: 'Cancel' }, { text: 'Discard' }]
 * });
 * if (choice === 'Discard') {
 *   // discard the draft
 * }
 * ```
 *
 * Using a custom component:
 * ```ts
 * @Component({
 *   template: `
 *     <h3>Heading 1</h3>
 *     <p>Paragraph 1</p>
 *     <h3>Heading 2</h3>
 *     <p>Paragraph 2</p>
 *   `
 * })
 * class FancyDialogComponent {}
 *
 * slDialogService.open({
 *   title: 'My title',
 *   component: FancyDialogComponent,
 * });
 * ```
 */
class SlDialogService {
    constructor(matDialog) {
        this.matDialog = matDialog;
    }
    /**
     * Resolves when the dialog is closed. Resolves to the {@link DialogButton.value} of the clicked button, or to `undefined` if the dialog was closed another way (such as clicking off it).
     */
    open(data) {
        return __awaiter(this, void 0, void 0, function* () {
            const ref = this.matDialog.open(DialogComponent, {
                data,
                autoFocus: false,
            });
            return firstValueFrom(ref.beforeClosed());
        });
    }
}
SlDialogService.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "14.0.3", ngImport: i0, type: SlDialogService, deps: [{ token: i3.MatDialog }], target: i0.ɵɵFactoryTarget.Injectable });
SlDialogService.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "14.0.3", ngImport: i0, type: SlDialogService, providedIn: 'root' });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "14.0.3", ngImport: i0, type: SlDialogService, decorators: [{
            type: Injectable,
            args: [{ providedIn: 'root' }]
        }], ctorParameters: function () { return [{ type: i3.MatDialog }]; } });

/*
 * Public API Surface of ng-mat-core
 */

/**
 * Generated bundle index. Do not edit.
 */

export { DEFAULT_OK_VALUE, SL_DIALOG_DATA, SlDialogHarness, SlDialogModule, SlDialogService };
//# sourceMappingURL=ng-mat-core.mjs.map
